Subject: Re: [PATCH] Support hidpi fringes and images with Cairo

From: Carlos Pita <[email-masked]>
Date: Sat, 26 Oct 2019 05:05:52 -0300

Here is an attempt to fix the above issues:

https://github.com/memeplex/emacs/commit/473beb25dd947c34392708ca40f1b3bf80613007

* It uses the scaling mechanism already present in image.c (notice
that imagemagick does its own scaling), so it works even without cairo
(except for fringes, of course).

* It removes the auto :scale property. I think this is the right thing
to do, applications that want to use the :scale parameter to transform
their images shouldn't lose the hidpi scaling nor explicitly call
image-compute-scaling-factor.

* The scale factor is slightly different than the one computed by
image-compute-scaling-factor, but anyway it's the scale factor that
was already computed by x/w32_scale_factor. Moreover, it has separated
x and y values.

A bit surprisingly the patch results in a code reduction of ~20LOC.
And there are image-compute-scaling-factor and image-scaling-factor
still remaining in image.el. The only user inside emacs is shr.el.